/* Javascript */


const mapa = [
    ['X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X'], // y=0
    ['X', ' ', ' ', 'X', ' ', ' ', ' ', ' ', 'X', ' ', 'X'], // y=1
    ['X', ' ', ' ', 'X', 'X', ' ', 'X', ' ', 'X', ' ', 'X'], // y=2
    ['X', ' ', 'X', 'X', ' ', ' ', 'X', ' ', 'X', ' ', 'X'], // y=3
    ['X', ' ', 'X', ' ', ' ', 'X', 'X', ' ', ' ', ' ', 'X'], // y=4
    ['X', ' ', ' ', ' ', ' ', 'X', 'X', 'X', 'X', ' ', 'X'], // y=5
    ['X', ' ', ' ', 'X', ' ', 'X', ' ', ' ', ' ', ' ', 'X'], // y=6
    ['X', ' ', 'X', 'X', ' ', 'X', ' ', 'X', 'X', 'X', 'X'], // y=7
    ['X', ' ', ' ', 'X', ' ', 'X', ' ', ' ', ' ', ' ', 'X'], // y=8
    ['X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X']  // y=9
]
// uvodni pozice hrace
const start = {x: 1, y: 1}
// kam se chce dostat
const end = {x: 9, y: 1}

// pole uvodnich pozic prekazek
const prisery = [
    {pohyb: 'random', x: 4, y: 3},
    {pohyb: 'greedy', x: 7, y: 4}
]

let player = start

//
function vykresli() {
    const hraciDeska = document.getElementById('hraci-deska')
    // vnejsi cyklus: po jednotlivych radkach
    for (let y = 0; y < mapa.length; y++) {
        const radka = mapa[y];
        let radkaElement = document.getElementById(`radka_${y}`)
        if (!radkaElement) {
            radkaElement = document.createElement('div')
            radkaElement.classList.add('radka') // v CSS: .radka { ... }
            radkaElement.id = `radka_${y}`
            hraciDeska.appendChild(radkaElement)
        }

        // vnitrni cyklus: po polickach v ramci jedne radky
        for (let x = 0; x < radka.length; x++) {
            let policko = document.getElementById(`policko_${x}_${y}`)
            if (!policko) {
                policko = document.createElement('div')
                policko.classList.add('policko') // v CSS: .policko { ... }
                policko.id = `policko_${x}_${y}`
                radkaElement.appendChild(policko)
            }

            if (mapa[y][x] == 'X') {
                policko.style.backgroundImage = "url('yoshi-32/yoshi-32-wall.png')"
            } else if (mapa[y][x] == 'W') {
                // voda 
                policko.style.backgroundImage = "url('water.png')"
            } else if (player.x == x && player.y == y) {
                // hrac 
                policko.style.backgroundImage = "url('yoshi-32/yoshi-32-worker.png')"
            } else if (prisery[0].x == x && prisery[0].y == y) {
                // prisera 1
                policko.style.backgroundImage = "url('yoshi-32/monster.png')"
            } else if (prisery[1].x == x && prisery[1].y == y) {
                // prisera 2
                policko.style.backgroundImage = "url('yoshi-32/monster.png')"
            } else if (end.x == x && end.y == y) {
                // Cil
                policko.style.backgroundImage = "url('yoshi-32/yoshi-32-dock.png')"
            } else {
                // prazdno
                policko.style.backgroundImage = "url('yoshi-32/yoshi-32-floor.png')"
            }
        }
    }
}

function pohybHrace(event) {
    let cilovaX = player.x
    let cilovaY = player.y
    if (!bylPohyb && event.code == "ArrowDown") {
        // ukazkovy pohyb panacka dolu
        cilovaY = player.y + 1
        cilovaX = player.x
    }
    if (!bylPohyb && event.code == "ArrowLeft") {
        // pohyb vlevo
        cilovaY = player.y
        cilovaX = player.x - 1
    }
    if (!bylPohyb && event.code == "ArrowRight") {
        // pohyb vpravo
        cilovaY = player.y
        cilovaX = player.x + 1
    }
    if (!bylPohyb && event.code == "ArrowUp") {
        // pohyb nahoru
        cilovaY = player.y - 1
        cilovaX = player.x
    }
    if (mapa[cilovaY][cilovaX] == ' ' || mapa[cilovaY][cilovaX] == 'W') {
        player.x = cilovaX
        player.y = cilovaY
        bylPohyb = true
    }
}

document.addEventListener("keydown", pohybHrace);


// objekt musi mit x a y
function jeVolnoNa(cilovaPozice) {
    return (mapa[cilovaPozice.y][cilovaPozice.x] != 'X' &&
        mapa[cilovaPozice.y][cilovaPozice.x] != 'W')
}


/* Zde pracujeme na pohybu priser*/
function pohniPriseru(cisloPrisery) {
    if (prisery[cisloPrisery].pohyb == "random") {
        random(prisery[cisloPrisery], player)
    } else if (prisery[cisloPrisery].pohyb == "greedy") {
        greedy(prisery[cisloPrisery], player)
    } else {
        throw "Neznamy typ pohybu prisery " + cisloPrisery
    }
}

setInterval(function () {
    vykresli()
    for (let i = 0; i < prisery.length; i++) {
        pohniPriseru(i)
    }

    /* Hledani cesty hrace: DFS */
    // Budu potrebovat velikost mapy:
    const vyskaMapy = mapa.length // pocet radku v mape
    // predpoklad: vsechny radky jsou stejne dlouhe (sirka mapy v kazdem radku je stejna)
    const sirkaMapy = mapa[0].length // pocet bunek v prvnim radku

    // vytvorim si nad mapou novou vrstvu s cisly: cislo udava, za kolik tahu se na policko dostanu
    // na zacatku jsou ve vrstve hodnoty null - vyznam "sem se nedostanes", jen na vychozim bode je 0
    // Moderni zpusob vytvoreni - https://stackoverflow.com/q/966225
    let kroky = Array(vyskaMapy).fill(0).map(x => Array(sirkaMapy).fill(null))
    // (alternativne je mozne napsat klasicky for cyklus jako cviceni)

    // Nastavim vychozi policko na 0
    kroky[player.y][player.x] = 0
    //console.log(kroky)
    let dosloKeZlepseni = true
    while (dosloKeZlepseni) {
        // tohle bud nektery krok zmeni na true, nebo muzeme cyklus ukoncit
        dosloKeZlepseni = false
        for (let y = 0; y < vyskaMapy; y++) {
            for (let x = 0; x < sirkaMapy; x++) {
                // toto se provede pro kazdou bunku
                if (mapa[y][x] == ' ' && kroky[y][x] == null) {
                    // dosud nenavstivena prazdna bunka.
                    // odkud do ni dovedeme prijit?
                    if (kroky[y][x - 1] != null) {
                        //zleva: pro navstevu teto bunky pripocitame krok
                        kroky[y][x] = kroky[y][x - 1] + 1
                    }
                    if (kroky[y][x + 1] != null) {
                        // zprava
                        kroky[y][x] = kroky[y][x + 1] + 1
                    }
                    if (kroky[y + 1][x] != null) {
                        // zdola
                        kroky[y][x] = kroky[y + 1][x] + 1
                    }
                    if (kroky[y - 1][x] != null) {
                        // shora
                        kroky[y][x] = kroky[y - 1][x] + 1
                    }
                    // pokud jsme prepsali null nejakym cislem, objevili jsme dalsi bunku do ktere se dostaneme
                    if (kroky[y][x] != null) {
                        dosloKeZlepseni = true
                    }
                }
            }
        }
    }
    // Vypis si pro jistotu vysledne pole:
    // console.log(kroky)

    // Ted vim zda se do cile dostanu
    if (kroky[end.y][end.x] != null && kroky[end.y][end.x] > 0) {
        console.log(`Dostanu se do cíle za ${kroky[end.y][end.x]} kroků`)

        // A jak se tam dostat? Provedu backtracking - musim jit opacne! Od cile ke startu
        let backtrack = {x: end.x, y: end.y}
        let predchoziPozice = null
        while (kroky[backtrack.y][backtrack.x] > 0) {
            predchoziPozice = {x: backtrack.x, y: backtrack.y}
            if (kroky[backtrack.y][backtrack.x] == kroky[backtrack.y][backtrack.x + 1] + 1) {
                // puvodne jsem sem prisel zprava, posun se tam zpatky
                backtrack.x += 1
            } else if (kroky[backtrack.y][backtrack.x] == kroky[backtrack.y][backtrack.x - 1] + 1) {
                // puvodne jsem sem prisel zleva, posun se tam zpatky
                backtrack.x -= 1
            } else if (kroky[backtrack.y][backtrack.x] == kroky[backtrack.y - 1][backtrack.x] + 1) {
                // puvodne jsem sem prisel shora, posun se tam zpatky
                backtrack.y -= 1
            } else if (kroky[backtrack.y][backtrack.x] == kroky[backtrack.y + 1][backtrack.x] + 1) {
                // puvodne jsem sem prisel zdola, posun se tam zpatky
                backtrack.y += 1
            }else {
                // Tohle je abychom nemeli nekonecny cyklus v pripade chyby - misto toho spadnem
                throw "Backtracking selhal"
            }
        }
        // Ukladal jsem si v backtrackingu predchozi pozici (tj. vlastne nasledujici policko v normalnim pohybu)
        // a to je prave ta nasledujici bunka pro muj pohyb smerem do cile!
        player.x = predchoziPozice.x
        player.y = predchoziPozice.y
    }

    // Pro zabavu: vyberu si nahodny novy cil, pokud jsem dosel na ten stary
    if(player.x == end.x && player.y == end.y){
        while(true){
            end.x = Math.floor(Math.random()*sirkaMapy)
            end.y = Math.floor(Math.random()*vyskaMapy)
            // pokud konci cil ve zdi, while(true) se postara ze to probehne znovu
            if (jeVolnoNa(end)){
                console.log(`novy cil ${end.x} ${end.y}`)
                // pokud ale cil neni ve zdi, while(true) cyklus se ukonci
                break
            }
        }
    }

    bylPohyb = false
}, 1000)

